jif.ast

## Class AmbPrincipalNode_c

- java.lang.Object
- - polyglot.ast.Node_c
  - - polyglot.ast.Term_c
    - - polyglot.ast.Expr_c
      - - jif.ast.PrincipalNode_c
        - - jif.ast.AmbPrincipalNode_c

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, ActsForParamNode<Principal>, AmbPrincipalNode, ParamNode, PrincipalNode, polyglot.ast.Ambiguous, polyglot.ast.Expr, polyglot.ast.ExprOps, polyglot.ast.Node, polyglot.ast.NodeOps, polyglot.ast.Prefix, polyglot.ast.Receiver, polyglot.ast.Term, polyglot.ast.TermOps, polyglot.ast.Typed, polyglot.util.Copy<polyglot.ast.Node>

      public class AmbPrincipalNode_c
      extends PrincipalNode_c
      implements AmbPrincipalNode

  An implementation of the `AmbPrincipalNode` interface.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface polyglot.util.Copy

      `polyglot.util.Copy.Util`

    - ### Nested classes/interfaces inherited from interface polyglot.ast.Term

      `polyglot.ast.Term.Instance`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected polyglot.ast.Expr` | `expr`
    `protected polyglot.ast.Id` | `name`

    - ### Fields inherited from class polyglot.ast.Expr_c

      `type`

    - ### Fields inherited from class polyglot.ast.Term_c

      `exceptions, reachable`

    - ### Fields inherited from class polyglot.ast.Node_c

      `del, error, ext, position`

    - ### Fields inherited from interface polyglot.ast.Term

      `ENTRY, EXIT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AmbPrincipalNode_c(polyglot.util.Position pos, polyglot.ast.Expr expr)`
    `AmbPrincipalNode_c(polyglot.util.Position pos, polyglot.ast.Expr expr, polyglot.ast.Ext ext)`
    `AmbPrincipalNode_c(polyglot.util.Position pos, polyglot.ast.Id name)`
    `AmbPrincipalNode_c(polyglot.util.Position pos, polyglot.ast.Id name, polyglot.ast.Ext ext)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `<T> java.util.List<T>` | `acceptCFG(polyglot.visit.CFGBuilder<?> v, java.util.List<T> succs)` Visit this term in evaluation order.
    `polyglot.ast.Node` | `disambiguate(polyglot.visit.AmbiguityRemover ar)`
    `protected polyglot.ast.Node` | `disambiguateName(polyglot.visit.AmbiguityRemover ar, polyglot.ast.Id name)`
    `protected <N extends AmbPrincipalNode_c> N` | `expr(N n, polyglot.ast.Expr expr)`
    `polyglot.ast.Term` | `firstChild()`
    `protected <N extends AmbPrincipalNode_c> N` | `id(N n, polyglot.ast.Id name)`
    `boolean` | `isDisambiguated()`
    `protected polyglot.ast.Node` | `paramToPrincipal(ParamInstance pi, polyglot.visit.AmbiguityRemover sc)`
    `protected polyglot.ast.Node` | `principalToPrincipal(PrincipalInstance vi, polyglot.visit.AmbiguityRemover sc)`
    `protected <N extends AmbPrincipalNode_c> N` | `reconstruct(N n, polyglot.ast.Expr expr, polyglot.ast.Id name)`
    `java.lang.String` | `toString()`
    `protected polyglot.ast.Node` | `varToPrincipal(JifVarInstance vi, polyglot.visit.AmbiguityRemover sc)`
    `polyglot.ast.Node` | `visitChildren(polyglot.visit.NodeVisitor v)`

    - ### Methods inherited from class jif.ast.PrincipalNode_c

      `parameter, parameter, principal, principal, throwTypes, typeCheck`

    - ### Methods inherited from class polyglot.ast.Expr_c

      `booleanValue, buildTypes, byteValue, charValue, constantValue, constantValue, constantValueSet, constantValueSet, doubleValue, dump, extRewrite, floatValue, intValue, isConstant, isConstant, isTypeChecked, lastLang, longValue, precedence, printSubExpr, printSubExpr, shortValue, stringValue, type, type, type`

    - ### Methods inherited from class polyglot.ast.Term_c

      `exceptionCheck, exceptions, exceptions, exceptions, listChild, reachable, reachable, reachable`

    - ### Methods inherited from class polyglot.ast.Node_c

      `addDecls, buildTypesEnter, checkConstants, childExpectedType, copy, copy, copy, copyIfNeeded, del, del, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, error, error, error, exceptionCheckEnter, ext, ext, ext, ext, extRewriteEnter, extRewriteOverride, lang, position, position, position, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, print, printBlock, printSubStmt, translate, typeCheckEnter, typeCheckOverride, visit, visitChild, visitEdge, visitList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jif.ast.PrincipalNode

      `principal, principal`

    - ### Methods inherited from interface jif.ast.ActsForParamNode

      `parameter, parameter`

    - ### Methods inherited from interface polyglot.ast.Expr

      `constantValue, constantValueSet, isConstant, precedence, printSubExpr, printSubExpr, type`

    - ### Methods inherited from interface polyglot.ast.Node

      `del, del, dump, error, error, ext, ext, ext, ext, isTypeChecked, position, position, visit, visitEdge`

    - ### Methods inherited from interface polyglot.ast.NodeOps

      `addDecls, buildTypes, buildTypesEnter, checkConstants, childExpectedType, copy, copy, disambiguateEnter, disambiguateOverride, dump, dump, dump, dump, enterChildScope, enterScope, exceptionCheck, exceptionCheckEnter, extRewrite, extRewriteEnter, extRewriteOverride, lang, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, throwTypes, translate, typeCheck, typeCheckEnter, typeCheckOverride, visitChild, visitList`

    - ### Methods inherited from interface polyglot.util.Copy

      `copy`

    - ### Methods inherited from interface polyglot.ast.Typed

      `type`

    - ### Methods inherited from interface polyglot.ast.Term

      `exceptions, exceptions, reachable, reachable`

- - ### Field Detail

    - #### expr

          protected polyglot.ast.Expr expr

    - #### name

          protected polyglot.ast.Id name

  - ### Constructor Detail

    - #### AmbPrincipalNode_c

          public AmbPrincipalNode_c(polyglot.util.Position pos,
                                    polyglot.ast.Expr expr)

    - #### AmbPrincipalNode_c

          public AmbPrincipalNode_c(polyglot.util.Position pos,
                                    polyglot.ast.Expr expr,
                                    polyglot.ast.Ext ext)

    - #### AmbPrincipalNode_c

          public AmbPrincipalNode_c(polyglot.util.Position pos,
                                    polyglot.ast.Id name)

    - #### AmbPrincipalNode_c

          public AmbPrincipalNode_c(polyglot.util.Position pos,
                                    polyglot.ast.Id name,
                                    polyglot.ast.Ext ext)

  - ### Method Detail

    - #### expr

          protected <N extends AmbPrincipalNode_c> N expr(N n,
                                                          polyglot.ast.Expr expr)

    - #### id

          protected <N extends AmbPrincipalNode_c> N id(N n,
                                                        polyglot.ast.Id name)

    - #### isDisambiguated

          public boolean isDisambiguated()

      Specified by:
        `isDisambiguated` in interface `polyglot.ast.Node`
      Overrides:
        `isDisambiguated` in class `PrincipalNode_c`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `PrincipalNode_c`

    - #### disambiguate

          public polyglot.ast.Node disambiguate(polyglot.visit.AmbiguityRemover ar)
                                         throws polyglot.types.SemanticException

      Specified by:
        `disambiguate` in interface `polyglot.ast.NodeOps`
      Overrides:
        `disambiguate` in class `polyglot.ast.Node_c`
      Throws:
        `polyglot.types.SemanticException`

    - #### disambiguateName

          protected polyglot.ast.Node disambiguateName(polyglot.visit.AmbiguityRemover ar,
                                                       polyglot.ast.Id name)
                                                throws polyglot.types.SemanticException

      Throws:
        `polyglot.types.SemanticException`

    - #### varToPrincipal

          protected polyglot.ast.Node varToPrincipal(JifVarInstance vi,
                                                     polyglot.visit.AmbiguityRemover sc)
                                              throws polyglot.types.SemanticException

      Throws:
        `polyglot.types.SemanticException`

    - #### principalToPrincipal

          protected polyglot.ast.Node principalToPrincipal(PrincipalInstance vi,
                                                           polyglot.visit.AmbiguityRemover sc)
                                                    throws polyglot.types.SemanticException

      Throws:
        `polyglot.types.SemanticException`

    - #### paramToPrincipal

          protected polyglot.ast.Node paramToPrincipal(ParamInstance pi,
                                                       polyglot.visit.AmbiguityRemover sc)
                                                throws polyglot.types.SemanticException

      Throws:
        `polyglot.types.SemanticException`

    - #### acceptCFG

          public <T> java.util.List<T> acceptCFG(polyglot.visit.CFGBuilder<?> v,
                                                 java.util.List<T> succs)

      Visit this term in evaluation order.
      Specified by:
        `acceptCFG` in interface `polyglot.ast.TermOps`
      Specified by:
        `acceptCFG` in class `polyglot.ast.Term_c`

    - #### firstChild

          public polyglot.ast.Term firstChild()

      Specified by:
        `firstChild` in interface `polyglot.ast.TermOps`
      Specified by:
        `firstChild` in class `polyglot.ast.Term_c`

    - #### visitChildren

          public polyglot.ast.Node visitChildren(polyglot.visit.NodeVisitor v)

      Specified by:
        `visitChildren` in interface `polyglot.ast.NodeOps`
      Overrides:
        `visitChildren` in class `polyglot.ast.Node_c`

    - #### reconstruct

          protected <N extends AmbPrincipalNode_c> N reconstruct(N n,
                                                                 polyglot.ast.Expr expr,
                                                                 polyglot.ast.Id name)